#ifndef AM_H
#define AM_H
/*
**
**	$Id: am.h,v 1.2 1995/10/07 02:52:29 chris Exp $
**	$Revision: 1.2 $
**
**	$Filename: developer/am.h $
**	$Author: chris $
**	$Date: 1995/10/07 02:52:29 $ 
**	$Portability: ANSI $
**
**	am
**
**	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF RELOG AG.
**
**	COPYRIGHT (C) 1992-1995 BY RELOG AG, ZUERICH. ALL RIGHTS RESERVED.
**	NO PART OF THIS SOFTWARE MAY BE COPIED, REPRODUCED, OR TRANSMITTED
**	IN ANY FORM OR BY ANY MEANS,  WITHOUT THE PRIOR WRITTEN PERMISSION
**	OF RELOG AG.
**
*/

#include "os.h"
#include "capi-usr.h"

#include "arexx.h"


#define NUMBERSIZE		32			/* Max ISDN number size */
#define FILENAMESIZE	32			/* Max filename size */
#define PATHSIZE		128			/* Max path size */
#define PATHNAMESIZE	(128+32)	/* Max path + filename size */


/*
**	Struktur eines Anrufbeantworters
*/
struct AnsweringMachine
{
	/*
	**	Konfigurierbare Parameter
	*/
	U8		Controller;					/* Controller, auf dem er sitzt */
	U8		MSN[NUMBERSIZE];			/* Nummer, auf der er abnimmt */
	U8		RexxScript[PATHNAMESIZE];	/* Das auszufhrende REXX-Script */

	/*
	**	Interne Sachen
	*/
	U32		PLCI;
	U32		NCCI;
	U8		PState;						/* PLCI State */
	U8		CallingNumber[NUMBERSIZE];	/* Nummer des Anrufers */

	struct BChannel *BChannel;			/* B-Kanal des Anrufs */
	U32		Process;					/* Handler-Prozess */

	struct BChannel_Job	*BGJob;			/* Hintergrundmusik-Job */

	char	KeyBuffer[16];				/* Die Touchtones */
	U16		KeyBufferSize;				/* Anzahl gltige Touchtones im Puffer */
};


/*
**	Prototypes
*/

U32
SendCAPIMessage( CAPI_MESSAGE *, U8 * );

RexxFunc	RXFunc_Background;
RexxFunc	RXFunc_Fade;
RexxFunc	RXFunc_HangUp;
RexxFunc	RXFunc_Play;
RexxFunc	RXFunc_Record;
RexxFunc	RXFunc_WaitKey;


#endif
